import pygame

from pykitten.gui import ClickArea

from widgets import *
from menus import *
from stuff import *

class Report(PopUpMenu):
    def __init__(self, game):
        self.game = game
        PopUpMenu.__init__(self, game.screen, GFX["report.png"])
            
        wpos = utils.center(GFX["report.png"].get_size(), (800,600))
        flag = FLAG[game.player.color+"_m"]
        x = utils.center(flag.get_size(), (360,264))[0]
        self.bg.blit(flag, (x+wpos[0], 20+wpos[1]))
        msg = ""
        nobattle = []
        self.report = game.reports
        for r in self.report:
            if r["defender"] == game.player.color:
                if r["battle"]:
                    line = r["attacker"] + " attacked " + r["dest"] + \
                        " from " + r["from"] + "."
                    if r["win"] > 0:
                        line = line + "You won,"
                    elif r["win"] < 0:
                        line = line + "You were defeated,"
                    else:
                        line = line + "You successfully defended,"
                    line = line + "losing " + r["lost"]+" units and "+\
                        "killing " + r["killed"] + "."
                    msg = msg + line + "\n\n"
                else:
                    nobattle.append(r["dest"])
        
        if nobattle:
            if msg:
                msg = msg + "Additionally,"
            
            if len(nobattle) == 1:
                msg = msg + nobattle[0] + " is now "
            else:
                for i in xrange(len(nobattle)-1):
                    msg = msg + nobattle[i] + ","
                msg = msg[:-1] #remove trailing comma
                msg = msg + "and " + nobattle[-1] +" are now"
            msg = msg + "occupied by enemy troops."
        
        img = BitMapTextArea(width=320, bgcolor=(0,0,0), msg=msg)
        # (22,118) 360,102
        sx, sy = utils.center(GFX["report.png"].get_size(), (800,600))
        x = 22 + sx
        y = utils.center(img.get_size(), (360,85))[1] + sy +118
        
        self.bg.blit(img, (x,y))
        self.game.reports = []
        
        clicky = ClickArea([0,0,800,600], callback=self.quit)
        self.widgets.append(clicky)
        
        #fizzlefizzle
        self.fizzle = self.game.fizzle
        self.fizzle.bg.blit(GFX["general.png"], (35,30))
        self.fizzle.active = 1
    
    def update_screen(self):
        if self.fizzle.update():
            self.fizzle.draw(self.bg)
            self.screen.blit(self.bg, (0,0))
            pygame.display.flip()
    
    def quit(self):
        PopUpMenu.quit(self)
        self.fizzle.active = 0
        self.game.conti.update_player()
