""" some handy stuff
"""

class Timer:
    """Basic timer class
    Attributes: counter, interval, active

    Can be used to count stuff or to time events.
    """
    def __init__(self, interval):
        """Timer constructor
        interval: max value for counter
        counter: counter is increased with each update
        """
        self.counter = 0
        self.interval = interval
        self.active = True

    def update(self, n=1):
        """ counter increased by n
        return True if counter is bigger than interval ("The time has come..")
        otherwise return False
        """
        if not self.active:
            return None

        self.counter += n
        if self.counter >= self.interval:  #pling!
            self.counter = 0
            return True
        return False

    def set_interval(self, value):
        """ Set interval to value, counter reset to 0
        """
        self.counter = 0
        self.interval = value

    def deactivate(self):
        self.active = False

    def activate(self):
        """ reset counter to 0 and activate to True
        """
        self.counter = 0
        self.active = True

    def resume(self):
        """ set active to true without resetting the counter
        """
        self.active = True


def center(img_size, sur_size):
    """returns center pos for img on surface
    Note that you need to pass the SIZES of the image and the surface.
    """
    img_x, img_y = img_size
    sur_x, sur_y = sur_size
    center_x = sur_x/2 - img_x/2
    center_y = sur_y/2 - img_y/2
    return [center_x, center_y]
